
# pvmodule

This library is a work in progress where the main objective is to create an easy to use and complete library to simulate photovoltaic energy production throughout multiple scenarios.





## Defining the location 

```python
from pvmodule.location import Location
from pvmodule.pvgis import PVGIS

Location = Location()
location = Location.set_location('Lisbon')

print(location.name)

>>> Lisboa, Portugal

```

## Retrieving Hourly data from PVGIS

```python
from pvmodule.location import Location
from pvmodule.pvgis import PVGIS

Location = Location()
location = Location.set_location('Oeiras')

PVGIS = PVGIS()
input, output, meta = PVGIS.retrieve_hourly(
                                            latitude=location.latitude, 
                                            longitude=location.longitude
                                            )
```

## Retrieving daily data from PVGIS (July)

```python
from pvmodule.location import Location
from pvmodule.pvgis import PVGIS

Location = Location()
location = Location.set_location('Oeiras')

PVGIS = PVGIS()
input, output, meta = PVGIS.retrieve_daily(
                                           latitude=location.latitude, 
                                           longitude=location.longitude,
                                           month=6
                                           )

```

## Retrieving Monthly data from PVGIS (July)

```python
from pvmodule.location import Location
from pvmodule.pvgis import PVGIS

Location = Location()
location = Location.set_location('Oeiras')

PVGIS = PVGIS()
input, output, meta = PVGIS.retrieve_monthly(
                                            latitude = location.latitude,
                                            longitude = location.longitude, 
                                            month=6
                                            )

```
